## python-numpy 1.16.2

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

PYVER = 3
PYTHON = python$(PYVER)

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = LANG=C sphinx-build
PAPER         =

FILES=

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d build/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help clean html web pickle htmlhelp latex changes linkcheck \
        dist dist-build gitwash-update

#------------------------------------------------------------------------------

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html      to make standalone HTML files"
	@echo "  html-scipyorg  to make standalone HTML files with scipy.org theming"
	@echo "  pickle    to make pickle files (usable by e.g. sphinx-web)"
	@echo "  htmlhelp  to make HTML files and a HTML help project"
	@echo "  latex     to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  changes   to make an overview over all changed/added/deprecated items"
	@echo "  linkcheck to check all external links for integrity"
	@echo "  dist PYVER=... to make a distribution-ready tree"
	@echo "  gitwash-update GITWASH=path/to/gitwash  update gitwash developer docs"
	@echo "  upload USERNAME=... RELEASE=... to upload built docs to docs.scipy.org"

clean:
	-rm -rf build/* source/reference/generated

gitwash-update:
	rm -rf source/dev/gitwash
	install -d source/dev/gitwash
	python $(GITWASH)/gitwash_dumper.py source/dev NumPy \
	    --repo-name=numpy \
	    --github-user=numpy
	cat source/dev/gitwash_links.txt >> source/dev/gitwash/git_links.inc

#------------------------------------------------------------------------------
# Automated generation of all documents
#------------------------------------------------------------------------------

# Build the current numpy version, and extract docs from it.
# We have to be careful of some issues:
# 
# - Everything must be done using the same Python version
# - We must use eggs (otherwise they might override PYTHONPATH on import).
# - Different versions of easy_install install to different directories (!)
#


INSTALL_DIR = $(CURDIR)/build/inst-dist/
INSTALL_PPH = $(INSTALL_DIR)/lib/python$(PYVER)/site-packages:$(INSTALL_DIR)/local/lib/python$(PYVER)/site-packages:$(INSTALL_DIR)/lib/python$(PYVER)/dist-packages:$(INSTALL_DIR)/local/lib/python$(PYVER)/dist-packages
UPLOAD_DIR=/srv/docs_scipy_org/doc/numpy-$(RELEASE)

DIST_VARS=SPHINXBUILD="LANG=C PYTHONPATH=$(INSTALL_PPH) python$(PYVER) `which sphinx-build`" PYTHON="PYTHONPATH=$(INSTALL_PPH) python$(PYVER)" SPHINXOPTS="$(SPHINXOPTS)"

dist:
	make $(DIST_VARS) real-dist

real-dist: dist-build html html-scipyorg
	test -d build/latex || make latex
	make -C build/latex all-pdf
	-test -d build/htmlhelp || make htmlhelp-build
	-rm -rf build/dist
	cp -r build/html-scipyorg build/dist
	cd build/html && zip -9r ../dist/numpy-html.zip .
	cp build/latex/numpy-ref.pdf build/dist
	cp build/latex/numpy-user.pdf build/dist
	cd build/dist && tar czf ../dist.tar.gz *
	chmod ug=rwX,o=rX -R build/dist
	find build/dist -type d -print0 | xargs -0r chmod g+s

dist-build:
	rm -f ../dist/*.egg
	cd .. && $(PYTHON) setup.py bdist_egg
	install -d $(subst :, ,$(INSTALL_PPH))
	$(PYTHON) `which easy_install` --prefix=$(INSTALL_DIR) ../dist/*.egg

upload:
	# SSH must be correctly configured for this to work.
	# Assumes that ``make dist`` was already run
	# Example usage: ``make upload USERNAME=rgommers RELEASE=1.10.1``
	ssh $(USERNAME)@docs.scipy.org mkdir $(UPLOAD_DIR)
	scp build/dist.tar.gz $(USERNAME)@docs.scipy.org:$(UPLOAD_DIR)
	ssh $(USERNAME)@docs.scipy.org tar xvC $(UPLOAD_DIR) \
	    -zf $(UPLOAD_DIR)/dist.tar.gz
	ssh $(USERNAME)@docs.scipy.org mv $(UPLOAD_DIR)/numpy-ref.pdf \
	    $(UPLOAD_DIR)/numpy-ref-$(RELEASE).pdf
	ssh $(USERNAME)@docs.scipy.org mv $(UPLOAD_DIR)/numpy-user.pdf \
	    $(UPLOAD_DIR)/numpy-user-$(RELEASE).pdf
	ssh $(USERNAME)@docs.scipy.org mv $(UPLOAD_DIR)/numpy-html.zip \
	    $(UPLOAD_DIR)/numpy-html-$(RELEASE).zip
	ssh $(USERNAME)@docs.scipy.org rm $(UPLOAD_DIR)/dist.tar.gz
	ssh $(USERNAME)@docs.scipy.org ln -snf numpy-$(RELEASE) /srv/docs_scipy_org/doc/numpy

#------------------------------------------------------------------------------
# Basic Sphinx generation rules for different formats
#------------------------------------------------------------------------------

generate: build/generate-stamp
build/generate-stamp: $(wildcard source/reference/*.rst)
	mkdir -p build
	touch build/generate-stamp

html: generate
	mkdir -p build/html build/doctrees
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) build/html $(FILES)
	$(PYTHON) postprocess.py html build/html/*.html
	@echo
	@echo "Build finished. The HTML pages are in build/html."

html-scipyorg:
	mkdir -p build/html build/doctrees
	$(SPHINXBUILD) -t scipyorg -b html $(ALLSPHINXOPTS) build/html-scipyorg $(FILES)
	@echo
	@echo "Build finished. The HTML pages are in build/html."

pickle: generate
	mkdir -p build/pickle build/doctrees
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) build/pickle $(FILES)
	@echo
	@echo "Build finished; now you can process the pickle files or run"
	@echo "  sphinx-web build/pickle"
	@echo "to start the sphinx-web server."

web: pickle

htmlhelp: generate
	mkdir -p build/htmlhelp build/doctrees
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) build/htmlhelp $(FILES)
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in build/htmlhelp."

htmlhelp-build: htmlhelp build/htmlhelp/numpy.chm
%.chm: %.hhp
	-hhc.exe $^

qthelp: generate
	mkdir -p build/qthelp build/doctrees
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) build/qthelp $(FILES)

latex: generate
	mkdir -p build/latex build/doctrees
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) build/latex $(FILES)
	$(PYTHON) postprocess.py tex build/latex/*.tex
	perl -pi -e 's/\t(latex.*|pdflatex) (.*)/\t-$$1 -interaction batchmode $$2/' build/latex/Makefile
	@echo
	@echo "Build finished; the LaTeX files are in build/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

coverage: build
	mkdir -p build/coverage build/doctrees
	$(SPHINXBUILD) -b coverage $(ALLSPHINXOPTS) build/coverage $(FILES)
	@echo "Coverage finished; see c.txt and python.txt in build/coverage"

changes: generate
	mkdir -p build/changes build/doctrees
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) build/changes $(FILES)
	@echo
	@echo "The overview file is in build/changes."

linkcheck: generate
	mkdir -p build/linkcheck build/doctrees
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) build/linkcheck $(FILES)
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in build/linkcheck/output.txt."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) build/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in build/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) build/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C build/texinfo info
	@echo "makeinfo finished; the Info files are in build/texinfo."

=== debian/changelog ===
python-numpy (1:1.16.2-1) unstable; urgency=medium

  * New upstream release

 -- Sandro Tosi <morph@debian.org>  Sat, 02 Mar 2019 11:30:12 -0500

python-numpy (1:1.16.1-1) unstable; urgency=medium

  * New upstream release

 -- Sandro Tosi <morph@debian.org>  Thu, 31 Jan 2019 22:21:17 -0500

python-numpy (1:1.16.0-1) unstable; urgency=medium

  * New upstream release

 -- Sandro Tosi <morph@debian.org>  Thu, 17 Jan 2019 22:49:04 -0500

python-numpy (1:1.16.0~rc2-2) unstable; urgency=medium

  * Team upload.

  [ Ondřej Nový ]
  * d/changelog: Remove trailing whitespaces.

  [ Emilio Pozuelo Monfort ]
  * Add more breaks for older versions of packages not compatible with
    Numpy 1.16.
  * Fix breaks on python-astropy. Closes: #918544.

 -- Emilio Pozuelo Monfort <pochu@debian.org>  Fri, 11 Jan 2019 14:51:15 +0100

python-numpy (1:1.16.0~rc2-1) unstable; urgency=medium

  * New upstream release candidate
  * debian/control
    - restore b-d on libblas-dev and liblapack-dev, instead of
      libatlas-base-dev; Closes: #913567
    - Add Breaks for packages not compatible with 1.16; Closes: #918399
  * debian/copyright
    - extend packaging copyright years
    - update upstream copyright years
  * debian/patches/0007-fix-test_various_alignments.patch
    - drop, applied upstream

 -- Sandro Tosi <morph@debian.org>  Sat, 05 Jan 2019 19:54:44 -0500

python-numpy (1:1.16.0~rc1-3) unstable; urgency=medium

  * debian/control
    - add pkg_resources to Depends, needed by f2py; Closes: #917878

 -- Sandro Tosi <morph@debian.org>  Mon, 31 Dec 2018 14:39:01 -0500

python-numpy (1:1.16.0~rc1-2) unstable; urgency=medium

  * debian/patches/0007-fix-test_various_alignments.patch
    - fix FTBFS on i386 archs due to tests suite being Aborted
  * debian/control
    - bump Standards-Version to 4.3.0 (no changes needed)

 -- Sandro Tosi <morph@debian.org>  Wed, 26 Dec 2018 11:37:59 -0500

python-numpy (1:1.16.0~rc1-1) unstable; urgency=medium

  * New upstream release candidate
  * debian/copyright
    - update upstream copyright years
  * debian/patch
    - refresh, drop
  * debian/rules
    - remove override_dh_python2, no longer needed
  * debian/versions
    - update ABI/API versions
  * debian/control
    - drop explicit b-d on python3.6-dev; Closes: #916821

 -- Sandro Tosi <morph@debian.org>  Mon, 24 Dec 2018 15:26:14 -0500

python-numpy (1:1.15.4-2) unstable; urgency=medium

  * debian/patches/python3-soabi.patch
    - fix skip syntax
  * debian/tests/control
    - switch from nose to pytest

 -- Sandro Tosi <morph@debian.org>  Thu, 22 Nov 2018 18:02:32 -0500

python-numpy (1:1.15.4-1) unstable; urgency=medium

  * New upstream release
  * debian/control
    - switch from nose to pytest
    - b-d on libatlas-base-dev
    - bump Standards-Version to 4.2.1 (no changes needed)
  * debian/copyright
    - add notice for doc/scipy-sphinx-theme/
  * debian/patches/*
    - refresh, drop patch merged upstream
  * debian/rules
    - run tests from debian/, to avoid pytest ImportMismatchError

 -- Sandro Tosi <morph@debian.org>  Sun, 11 Nov 2018 19:59:10 -0500

=== debian/control ===
Source: python-numpy
Section: python
Priority: optional
Maintainer: Sandro Tosi <morph@debian.org>
Uploaders: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
Build-Depends: cython (>= 0.26-2.1),
               debhelper (>= 11),
               dh-python,
               gfortran (>= 4:4.2),
               libblas-dev [!arm !m68k],
               liblapack-dev [!arm !m68k],
               python2.7-dev (>= 2.7.14~rc1-1),
               python-all-dbg,
               python3-all-dbg,
               python-all-dev,
               python3-all-dev,
               python-docutils,
               python3-matplotlib,
               python-pytest,
               python3-pytest,
               python-setuptools,
               python3-setuptools,
               python3-sphinx,
               python-tz,
               python3-tz,
Standards-Version: 4.3.0
Vcs-Git: https://salsa.debian.org/python-team/modules/python-numpy.git
Vcs-Browser: https://salsa.debian.org/python-team/modules/python-numpy
Homepage: http://www.numpy.org/

Package: python-numpy
Architecture: any
Depends: ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}, python-pkg-resources
Suggests: gcc (>= 4:4.6.1-5),
          gfortran,
          python-dev,
          python-pytest,
          python-numpy-dbg,
          python-numpy-doc
Provides: python-f2py, python-numpy-dev, ${numpy:Provides}, ${python:Provides}
Breaks: python-astropy (<= 2.0.9-1),
        python-pbcore (<< 1.6.5+dfsg-1),
        python-skimage (<< 0.14.1-3),
        python-tables (<< 3.4.4-2),
        python-theano (<< 1.0.3+dfsg-1),
Description: Numerical Python adds a fast array facility to the Python language
 Numpy contains a powerful N-dimensional array object, sophisticated
 (broadcasting) functions, tools for integrating C/C++ and Fortran
 code, and useful linear algebra, Fourier transform, and random number
 capabilities.
 .
 Numpy replaces the python-numeric and python-numarray modules which are
 now deprecated and shouldn't be used except to support older
 software.

Package: python-numpy-dbg
Section: debug
Architecture: any
Multi-Arch: same
Depends: python-dbg,
         python-numpy (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: python-numpy (<< 1:1.7.1-1)
Replaces: python-numpy (<< 1:1.7.1-1)
Description: Fast array facility to the Python language (debug extension)
 Numpy contains a powerful N-dimensional array object, sophisticated
 (broadcasting) functions, tools for integrating C/C++ and Fortran
 code, and useful linear algebra, Fourier transform, and random number
 capabilities.
 .
 Numpy replaces the python-numeric and python-numarray modules which
 are now deprecated and shouldn't be used except to support older
 software.
 .
 This package contains the extension built for the Python debug interpreter.

Package: python3-numpy
Architecture: any
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}, python3-pkg-resources
Suggests: gcc (>= 4:4.6.1-5),
          gfortran,
          python-numpy-doc,
          python3-dev,
          python3-pytest,
          python3-numpy-dbg
Provides: python3-f2py,
          python3-numpy-dev,
          ${numpy3:Provides},
          ${python3:Provides}
Breaks: python3-aplpy (<< 2.0~rc2-1),
        python3-astropy (<< 3.1-1),
        python3-ccdproc (<< 1.3.0-5),
        python3-dask (<< 1.0.0+dfsg-2),
        python3-skimage (<< 0.14.1-3),
        python3-tables (<< 3.4.4-2),
        python3-theano (<< 1.0.3+dfsg-1),
Description: Fast array facility to the Python 3 language
 Numpy contains a powerful N-dimensional array object, sophisticated
 (broadcasting) functions, tools for integrating C/C++ and Fortran
 code, and useful linear algebra, Fourier transform, and random number
 capabilities.
 .
 Numpy replaces the python-numeric and python-numarray modules which are
 now deprecated and shouldn't be used except to support older
 software.
 .
 This package contains Numpy for Python 3.

Package: python3-numpy-dbg
Section: debug
Architecture: any
Multi-Arch: same
Depends: python3-dbg,
         python3-numpy (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: python3-numpy (<< 1:1.7.1-1)
Replaces: python3-numpy (<< 1:1.7.1-1)
Description: Fast array facility to the Python 3 language (debug extension)
 Numpy contains a powerful N-dimensional array object, sophisticated
 (broadcasting) functions, tools for integrating C/C++ and Fortran
 code, and useful linear algebra, Fourier transform, and random number
 capabilities.
 .
 Numpy replaces the python-numeric and python-numarray modules which
 are now deprecated and shouldn't be used except to support older
 software.
 .
 This package contains the extension built for the Python 3 debug interpreter.

Package: python-numpy-doc
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Section: doc
Architecture: all
Multi-Arch: foreign
Description: NumPy documentation
 Numpy contains a powerful N-dimensional array object, sophisticated
 (broadcasting) functions, tools for integrating C/C++ and Fortran
 code, and useful linear algebra, Fourier transform, and random number
 capabilities.
 .
 Numpy replaces the python-numeric and python-numarray modules which
 are now deprecated and shouldn't be used except to support older
 software.
 .
 This package contains documentation for Numpy and f2py.

=== debian/rules ===
#!/usr/bin/make -f

DH_VERBOSE=1

PY2VERS=$(shell pyversions -vr debian/control)
PY3VERS=$(shell py3versions -vr)
PYDEF=$(shell pyversions -dv)
PY3DEF=$(shell py3versions -dv)
PYLIBPATH := $(shell python -c "from distutils.command.build import build ; from distutils.core import Distribution ; b = build(Distribution()) ; b.finalize_options() ; print b.build_platlib")
PY3LIBPATH := $(shell python3 -c "from distutils.command.build import build ; from distutils.core import Distribution ; b = build(Distribution()) ; b.finalize_options() ; print (b.build_platlib)")

# Look at #634012 to understand why is needed and what will happen if we set
# compat to 9
unexport LDFLAGS
export ATLAS=None

%:
	dh $@ --with python2,python3

override_dh_auto_build:
	cd numpy/random/mtrand && python generate_mtrand_c.py
	dh_auto_build
	set -e; for v in $(PY3VERS); do \
		python$$v setup.py build; \
		python$$v-dbg setup.py build; \
	done

	# build doc only for default python version
	(export MPLCONFIGDIR=. ; make -C doc html PYTHON=python3 PYTHONPATH=../$(PY3LIBPATH))

override_dh_auto_clean:
	rm -rf build/
	rm -rf `find -name build -type d`
	rm -rf `find . -name "*.pyc" -type f`
	rm -rf doc/fontList.cache numpy/f2py/docs/usersguide/index.html
	rm -rf doc/source/reference/generated
	# cython generated
	rm -f numpy/random/mtrand/mtrand.c

#override_dh_installman:
#	dh_installman -ppython-numpy doc/f2py/f2py.1
#	dh_installman -ppython3-numpy doc/f2py/f2py.1
#	-mv debian/python3-numpy/usr/share/man/man1/f2py.1 \
#	  debian/python3-numpy/usr/share/man/man1/f2py3.1
#	# link manpage for versioned and dbg incarnations of f2py
#	set -e; for v in $(PY2VERS); do \
#		dh_link -ppython-numpy /usr/share/man/man1/f2py.1.gz /usr/share/man/man1/f2py$$v.1.gz; \
#		dh_link -ppython-numpy-dbg /usr/share/man/man1/f2py.1.gz /usr/share/man/man1/f2py$$v-dbg.1.gz; \
#	done
#	set -e; for v in $(PY3VERS); do \
#		dh_link -ppython3-numpy /usr/share/man/man1/f2py3.1.gz /usr/share/man/man1/f2py$$v.1.gz; \
#		dh_link -ppython3-numpy-dbg /usr/share/man/man1/f2py3.1.gz /usr/share/man/man1/f2py$$v-dbg.1.gz; \
#	done
#	dh_link -ppython-numpy-dbg /usr/share/man/man1/f2py.1.gz /usr/share/man/man1/f2py-dbg.1.gz;
#	dh_link -ppython3-numpy-dbg /usr/share/man/man1/f2py3.1.gz /usr/share/man/man1/f2py3-dbg.1.gz;

override_dh_install:
	# add shebang information to f2py script
	set -e; for v in $(PY2VERS) $(PY3VERS); do \
		sed -i "1s,#!.*python[^ ]*\(.*\),#!/usr/bin/python$$v," debian/tmp/usr/bin/f2py$$v; \
		cp -a debian/tmp/usr/bin/f2py$$v debian/tmp/usr/bin/f2py$$v-dbg ; \
		sed -i "1s,#!.*python[^ ]*\(.*\),#!/usr/bin/python$$v-dbg," debian/tmp/usr/bin/f2py$$v-dbg; \
	done
	# install unversioned f2py script
	cp -a debian/tmp/usr/bin/f2py$(PYDEF) debian/tmp/usr/bin/f2py
	sed -i "1s,#!.*python[^ ]*\(.*\),#!/usr/bin/python," debian/tmp/usr/bin/f2py
	cp -a debian/tmp/usr/bin/f2py$(PYDEF)-dbg debian/tmp/usr/bin/f2py-dbg
	sed -i "1s,#!.*python[^ ]*\(.*\),#!/usr/bin/python-dbg," debian/tmp/usr/bin/f2py-dbg

	cp -a debian/tmp/usr/bin/f2py$(PY3DEF) debian/tmp/usr/bin/f2py3
	sed -i "1s,#!.*python[^ ]*\(.*\),#!/usr/bin/python3," debian/tmp/usr/bin/f2py3
	cp -a debian/tmp/usr/bin/f2py$(PY3DEF)-dbg debian/tmp/usr/bin/f2py3-dbg
	sed -i "1s,#!.*python[^ ]*\(.*\),#!/usr/bin/python3-dbg," debian/tmp/usr/bin/f2py3-dbg

	dh_install

	# remove files installed from .install (that's due to the dir listed there)
	-find $(CURDIR)/debian/python-numpy/ -name "*_d.so" -delete

	# create symlinks for .h files
	dh_link -ppython-numpy usr/lib/python$(PYDEF)/dist-packages/numpy/core/include/numpy usr/include/numpy;
	set -e; for i in $(PY2VERS); do \
	[ -d $(CURDIR)/debian/python-numpy/usr/include/python$$i ] || \
		mkdir -p $(CURDIR)/debian/python-numpy/usr/include/python$$i; \
		dh_link -ppython-numpy usr/lib/python$$i/dist-packages/numpy/core/include/numpy usr/include/python$$i/numpy; \
	done
	set -e; for i in $(PY2VERS); do \
	[ -d $(CURDIR)/debian/python-numpy-dbg/usr/include/python$${i}_d ] || \
		mkdir -p $(CURDIR)/debian/python-numpy-dbg/usr/include/python$${i}_d; \
		dh_link -ppython-numpy-dbg usr/lib/python$$i/dist-packages/numpy/core/include/numpy usr/include/python$${i}_d/numpy; \
	done
	# Python 3
	set -e; for i in $(PY3VERS); do \
	ABITAG=`python$$i -c "import sys; print(sys.abiflags)"`; \
	[ -d $(CURDIR)/debian/python3-numpy/usr/include/python$$i$$ABITAG ] || \
		mkdir -p $(CURDIR)/debian/python3-numpy/usr/include/python$$i$$ABITAG; \
		dh_link -ppython3-numpy usr/lib/python3/dist-packages/numpy/core/include/numpy usr/include/python$$i$$ABITAG/numpy; \
	done
	set -e; for i in $(PY3VERS); do \
	ABITAG=`python$$i-dbg -c "import sys; print(sys.abiflags)"`; \
	[ -d $(CURDIR)/debian/python3-numpy-dbg/usr/include/python$${i}$$ABITAG ] || \
		mkdir -p $(CURDIR)/debian/python3-numpy-dbg/usr/include/python$${i}$$ABITAG; \
		dh_link -ppython3-numpy-dbg usr/lib/python3/dist-packages/numpy/core/include/numpy/ usr/include/python$${i}$$ABITAG/numpy; \
	done

	# share -dbg and normal package doc dirs
	rm -rf debian/python-numpy-dbg/usr/share/doc/python-numpy-dbg
	dh_link -ppython-numpy-dbg usr/share/doc/python-numpy usr/share/doc/python-numpy-dbg
	rm -rf debian/python3-numpy-dbg/usr/share/doc/python3-numpy-dbg
	dh_link -ppython3-numpy-dbg usr/share/doc/python3-numpy usr/share/doc/python3-numpy-dbg

override_dh_gencontrol:
	python debian/versions.helper >> debian/python-numpy.substvars
	python debian/versions3.helper >> debian/python3-numpy.substvars
	dh_gencontrol

override_dh_compress:
	dh_compress -X.js -Xobjects.inv -X.txt

override_dh_strip:
ifeq (,$(filter nostrip,$(DEB_BUILD_OPTIONS)))
	dh_strip -ppython-numpy --dbg-package=python-numpy-dbg
	dh_strip -ppython3-numpy --dbg-package=python3-numpy-dbg
	# dh_strip seemingly doesn't catch the PEP 3149-style debug names
	rm debian/python3-numpy/usr/lib/python3*/*-packages/*/*/*.cpython-3?d*.so
endif


override_dh_installdocs-indep:
	dh_installdocs -i
	dh_sphinxdoc -i

update_intersphinx_mapping:
	wget http://docs.python.org/dev/objects.inv -O debian/python.org_objects.inv

override_dh_auto_install:
	dh_auto_install

	# Install for Python 3
	set -e; for v in $(PY3VERS); do \
		python$$v setup.py install --root=$(CURDIR)/debian/tmp --install-layout=deb; \
		python$$v-dbg setup.py install --root=$(CURDIR)/debian/tmp --install-layout=deb; \
	done

	# yes, we need to run tests after install
	# The reason is that numpy tries hard to not let you run it from the
	# source directory, so we need to mess with the import order so to
	# select the code in the installation path
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	set -e; for v in $(PY2VERS) ; do \
		cd debian ; \
		echo "-- running tests for "$$v" plain --" ; \
		python$$v -c "import sys ; sys.path.insert(0, './tmp/usr/lib/python$$v/dist-packages/') ; import numpy; numpy.test(verbose=5)" ; \
		echo "-- running tests for "$$v" debug --" ; \
		python$$v-dbg -c "import sys ; sys.path.insert(0, './tmp/usr/lib/python$$v/dist-packages/') ; import numpy; numpy.test(verbose=5)" ; \
		cd .. ; \
	done
	# Python 3.2 maps to python3/ dir alone? bah
	set -e; for v in $(PY3VERS) ; do \
		cd debian ; \
		echo "-- running tests for "$$v" plain --" ; \
		python$$v -c "import sys ; sys.path.insert(0, './tmp/usr/lib/python3/dist-packages/') ; import numpy; numpy.test(verbose=5)" ; \
		echo "-- running tests for "$$v" debug --" ; \
		python$$v-dbg -c "import sys ; sys.path.insert(0, './tmp/usr/lib/python3/dist-packages/') ; import numpy; numpy.test(verbose=5)" ; \
		cd .. ; \
	done
endif

=== debian/tests/control ===
Tests: python2
Depends: build-essential, python-numpy, python-all, python-pytest, python-tz

Tests: python3
Depends: build-essential, python3-numpy, python3-all, python3-pytest, python3-tz

#needs root for update-alternatives
Tests: openblas
Restrictions: needs-root
Depends: python-numpy, python-all, python-pytest, python-tz, libopenblas-base, dpkg-dev, gcc

#needs root for update-alternatives
Tests: atlas
Restrictions: needs-root
Depends: python-numpy, python-all, python-pytest, python-tz, libatlas3-base, dpkg-dev, gcc

Tests: f2py
Depends: build-essential, gfortran, python-numpy, python-numpy-dbg, python-all, python-all-dbg, python-all-dev, python3-numpy, python3-numpy-dbg, python3-all, python3-all-dbg, python3-all-dev

Tests: distutils
Restrictions: allow-stderr
Depends: build-essential, libfftw3-dev, python-numpy

Tests: capi
Depends: build-essential, python-all-dev, python-all-dbg, python3-all-dev, python3-all-dbg, python-numpy, python-numpy-dbg, python3-numpy, python3-numpy-dbg

=== debian/watch ===
version=4
opts=uversionmangle=s/(rc|a|b|c)/~$1/ \
https://pypi.debian.net/numpy/numpy-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
#opts="pgpmode=none" \
#    https://pypi.python.org/pypi/numpy/ \
#    https://pypi.python.org/packages/.*/.*/.*/numpy-([\d\.]+).zip#.*

## python-numpy 1.16.5

=== debian/changelog ===
python-numpy (1:1.16.5-2ubuntu7) focal; urgency=medium

  * No-change rebuild with fixed binutils on arm64.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 10 Feb 2020 08:23:35 +0100

python-numpy (1:1.16.5-2ubuntu6) focal; urgency=medium

  * Fix typo in debian/tests/capi and debian/tests/f2py
  * Do not run tests for unversioned executables in debian/tests/f2py

 -- Graham Inggs <ginggs@ubuntu.com>  Sun, 12 Jan 2020 10:18:30 +0000

python-numpy (1:1.16.5-2ubuntu5) focal; urgency=medium

  * Use the pybuild build system.
  * Disable running the tests. The tests are run in the install target.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 11 Jan 2020 12:06:55 +0100

python-numpy (1:1.16.5-2ubuntu2) focal; urgency=medium

  * python-numpy-dbg: Depend on python2-dbg instead of python-dbg.
  * Use python2 in the rules file.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 07 Jan 2020 13:39:04 +0100

python-numpy (1:1.16.5-2) unstable; urgency=medium

  [ Ondřej Nový ]
  * Bump Standards-Version to 4.4.1.

  [ Sandro Tosi ]
  * Drop py3k and -doc packages, taken over by src:numpy

 -- Sandro Tosi <morph@debian.org>  Tue, 12 Nov 2019 11:45:33 -0500

python-numpy (1:1.16.5-1) unstable; urgency=medium

  [ Ondřej Nový ]
  * Use debhelper-compat instead of debian/compat.
  * Bump Standards-Version to 4.4.0.

  [ Drew Parsons ]
  * move python3-matplotlib to Build-Depends-Indep. Build docs under
    override_dh_auto_build-indep. Thanks Jason Duerstock.
    Closes: #929975

  [ Sandro Tosi ]
  * New upstream release; Closes: #933056, #931541
  * debian/watch
    - only search for 1.16.x releases, the only ones supporting python2
  * debian/copyright
    - document numpy/linalg/lapack_lite/ copyright and license

 -- Sandro Tosi <morph@debian.org>  Sat, 07 Sep 2019 17:33:43 -0400

=== debian/control ===
Source: python-numpy
Section: python
Priority: optional
Maintainer: Sandro Tosi <morph@debian.org>
Uploaders: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
Build-Depends: cython (>= 0.26-2.1),
               debhelper-compat (= 11),
               dh-python,
               gfortran (>= 4:4.2),
               libblas-dev [!arm !m68k],
               liblapack-dev [!arm !m68k],
               python2.7-dev (>= 2.7.14~rc1-1),
               python-all-dbg,
               python-all-dev,
               python-docutils,
               python-pytest,
               python-setuptools,
               python-tz,
               python3-tz,
Standards-Version: 4.4.1
Vcs-Git: https://salsa.debian.org/python-team/modules/python-numpy.git
Vcs-Browser: https://salsa.debian.org/python-team/modules/python-numpy
Homepage: http://www.numpy.org/

Package: python-numpy
Architecture: any
Depends: ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}, python-pkg-resources
Suggests: gcc (>= 4:4.6.1-5),
          gfortran,
          python-dev,
          python-pytest,
          python-numpy-dbg,
          python-numpy-doc
Provides: python-f2py, python-numpy-dev, ${numpy:Provides}, ${python:Provides}
Breaks: python-astropy (<= 2.0.9-1),
        python-pbcore (<< 1.6.5+dfsg-1),
        python-skimage (<< 0.14.1-3),
        python-tables (<< 3.4.4-2),
        python-theano (<< 1.0.3+dfsg-1),
Description: Numerical Python adds a fast array facility to the Python language
 Numpy contains a powerful N-dimensional array object, sophisticated
 (broadcasting) functions, tools for integrating C/C++ and Fortran
 code, and useful linear algebra, Fourier transform, and random number
 capabilities.
 .
 Numpy replaces the python-numeric and python-numarray modules which are
 now deprecated and shouldn't be used except to support older
 software.

Package: python-numpy-dbg
Section: debug
Architecture: any
Multi-Arch: same
Depends: python2-dbg,
         python-numpy (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: python-numpy (<< 1:1.7.1-1)
Replaces: python-numpy (<< 1:1.7.1-1)
Description: Fast array facility to the Python language (debug extension)
 Numpy contains a powerful N-dimensional array object, sophisticated
 (broadcasting) functions, tools for integrating C/C++ and Fortran
 code, and useful linear algebra, Fourier transform, and random number
 capabilities.
 .
 Numpy replaces the python-numeric and python-numarray modules which
 are now deprecated and shouldn't be used except to support older
 software.
 .
 This package contains the extension built for the Python debug interpreter.

=== debian/rules ===
#!/usr/bin/make -f

DH_VERBOSE=1

PY2VERS=$(shell pyversions -vr debian/control)
PYDEF=$(shell pyversions -dv)
PYLIBPATH := $(shell python2 -c "from distutils.command.build import build ; from distutils.core import Distribution ; b = build(Distribution()) ; b.finalize_options() ; print b.build_platlib")

export PYBUILD_DISABLE=test

# Look at #634012 to understand why is needed and what will happen if we set
# compat to 9
unexport LDFLAGS
export ATLAS=None

%:
	dh $@ --with python2 --buildsystem=pybuild

override_dh_auto_build-arch:
	cd numpy/random/mtrand && python2 generate_mtrand_c.py
	dh_auto_build

override_dh_auto_clean:
	rm -rf build/
	rm -rf `find -name build -type d`
	rm -rf `find . -name "*.pyc" -type f`
	rm -rf doc/fontList.cache numpy/f2py/docs/usersguide/index.html
	rm -rf doc/source/reference/generated
	# cython generated
	rm -f numpy/random/mtrand/mtrand.c

override_dh_install:
	# add shebang information to f2py script
	set -e; for v in $(PY2VERS); do \
		sed -i "1s,#!.*python[^ ]*\(.*\),#!/usr/bin/python$$v," debian/tmp/usr/bin/f2py$$v; \
		cp -a debian/tmp/usr/bin/f2py$$v debian/tmp/usr/bin/f2py$$v-dbg ; \
		sed -i "1s,#!.*python[^ ]*\(.*\),#!/usr/bin/python$$v-dbg," debian/tmp/usr/bin/f2py$$v-dbg; \
	done
	# install unversioned f2py script
	cp -a debian/tmp/usr/bin/f2py$(PYDEF) debian/tmp/usr/bin/f2py
	sed -i "1s,#!.*python[^ ]*\(.*\),#!/usr/bin/python," debian/tmp/usr/bin/f2py
	cp -a debian/tmp/usr/bin/f2py$(PYDEF)-dbg debian/tmp/usr/bin/f2py-dbg
	sed -i "1s,#!.*python[^ ]*\(.*\),#!/usr/bin/python-dbg," debian/tmp/usr/bin/f2py-dbg

	dh_install

	# remove files installed from .install (that's due to the dir listed there)
	-find $(CURDIR)/debian/python-numpy/ -name "*_d.so" -delete

	# create symlinks for .h files
	dh_link -ppython-numpy usr/lib/python$(PYDEF)/dist-packages/numpy/core/include/numpy usr/include/numpy;
	set -e; for i in $(PY2VERS); do \
	[ -d $(CURDIR)/debian/python-numpy/usr/include/python$$i ] || \
		mkdir -p $(CURDIR)/debian/python-numpy/usr/include/python$$i; \
		dh_link -ppython-numpy usr/lib/python$$i/dist-packages/numpy/core/include/numpy usr/include/python$$i/numpy; \
	done
	set -e; for i in $(PY2VERS); do \
	[ -d $(CURDIR)/debian/python-numpy-dbg/usr/include/python$${i}_d ] || \
		mkdir -p $(CURDIR)/debian/python-numpy-dbg/usr/include/python$${i}_d; \
		dh_link -ppython-numpy-dbg usr/lib/python$$i/dist-packages/numpy/core/include/numpy usr/include/python$${i}_d/numpy; \
	done

	# share -dbg and normal package doc dirs
	rm -rf debian/python-numpy-dbg/usr/share/doc/python-numpy-dbg
	dh_link -ppython-numpy-dbg usr/share/doc/python-numpy usr/share/doc/python-numpy-dbg

override_dh_gencontrol:
	python2 debian/versions.helper >> debian/python-numpy.substvars
	dh_gencontrol

override_dh_compress:
	dh_compress -X.js -Xobjects.inv -X.txt

override_dh_strip:
ifeq (,$(filter nostrip,$(DEB_BUILD_OPTIONS)))
	dh_strip -ppython-numpy --dbg-package=python-numpy-dbg
endif


override_dh_installdocs-indep:
	dh_installdocs -i

override_dh_auto_install:
	dh_auto_install

	# yes, we need to run tests after install
	# The reason is that numpy tries hard to not let you run it from the
	# source directory, so we need to mess with the import order so to
	# select the code in the installation path
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	set -e; for v in $(PY2VERS) ; do \
		cd debian ; \
		echo "-- running tests for "$$v" plain --" ; \
		python$$v -c "import sys ; sys.path.insert(0, './tmp/usr/lib/python$$v/dist-packages/') ; import numpy; numpy.test(verbose=5)" ; \
		echo "-- running tests for "$$v" debug --" ; \
		python$$v-dbg -c "import sys ; sys.path.insert(0, './tmp/usr/lib/python$$v/dist-packages/') ; import numpy; numpy.test(verbose=5)" ; \
		cd .. ; \
	done
endif

=== debian/tests/control ===
Tests: python2
Depends: build-essential, python-numpy, python-all, python-pytest, python-tz

#needs root for update-alternatives
Tests: openblas
Restrictions: needs-root
Depends: python-numpy, python-all, python-pytest, python-tz, libopenblas-base, dpkg-dev, gcc

#needs root for update-alternatives
Tests: atlas
Restrictions: needs-root
Depends: python-numpy, python-all, python-pytest, python-tz, libatlas3-base, dpkg-dev, gcc

Tests: f2py
Depends: build-essential, gfortran, python-numpy, python-numpy-dbg, python-all, python-all-dbg, python-all-dev

Tests: distutils
Restrictions: allow-stderr
Depends: build-essential, libfftw3-dev, python-numpy

Tests: capi
Depends: build-essential, python-all-dev, python-all-dbg, python-numpy, python-numpy-dbg

=== debian/watch ===
version=4
opts=uversionmangle=s/(rc|a|b|c)/~$1/ \
https://pypi.debian.net/numpy/numpy-(1.16.*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
#opts="pgpmode=none" \
#    https://pypi.python.org/pypi/numpy/ \
#    https://pypi.python.org/packages/.*/.*/.*/numpy-([\d\.]+).zip#.*
